#! /usr/bin/env python

import sys
import array
from PIL import Image
import imp
import string

#sprite = imp.load_source('sprite', sys.path[0] + '/tilificator/trunk/sprite.py')
from sprite import *

def unifySpriteAnimations(spriteAnimationDirsBanks):
    # List of unique sprite images
    spriteImages = [None]

    # List of sprite animations
    spriteAnimations = []

    # Load each sprite animation, only adding a new spriteImage if it has not been encountered before
    for bank,spriteAnimationDirs in enumerate(spriteAnimationDirsBanks):
        for spriteAnimationDir in spriteAnimationDirs:
            sa = SpriteAnimation(spriteAnimationDir)
            sa.deltas = []
            for i,si in enumerate(sa.frameRefs):
                deltaX,deltaY = si.crop()
                sa.deltas.append((deltaX,deltaY))
                if sum(si.data) == 0:
                    si = None
                else:
                    dataList = [spriteImage.data for spriteImage in spriteImages if spriteImage != None]
                    if si.data in dataList:
                        si = spriteImages[dataList.index(si.data)+1]
                    else:
                        si.bank = bank
                        spriteImages.append(si)
                sa.frameRefs[i] = si
            spriteAnimations.append(sa)
            sa.name = spriteAnimationDir

    # Save unique sprite images
    #mkdir('uniqueImages')
    for i,si in enumerate(spriteImages):
        if si != None:
            si.save('uniqueimages_%d/%03d.png' % (si.bank,i))


    spriteAnimationDirs = []
    for s in spriteAnimationDirsBanks:
        spriteAnimationDirs += s 
    f = sys.stdout
    spriteImageRefs = [[] for i in range(len(spriteImages))] 
    for saIndex,sa in enumerate(spriteAnimations):
        f.write('ANIMATION_%s = %d\n' % (string.upper(sa.name),saIndex))
        f.write('SprAnimAddr_%s:\n' % sa.name)
        xAdd = -8 + sa.offsX
        yAdd = -8  + sa.offsY
        xAddFlipped = sa.flipAdjustX
        yAddFlipped = yAdd
        f.write('.lobytes %d,%d,%d,%d\n' % (xAdd,yAdd,xAddFlipped,yAddFlipped))
        for i,si in enumerate(sa.frameRefs):
            deltaX,deltaY = sa.deltas[i]
            #deltaX += xAdd
            deltaY += yAdd #+128
            sprIndex = spriteImages.index(sa.frameRefs[i])-1
            if spriteImages.index(sa.frameRefs[i]):
                f.write('.lobytes %d,%d,%d,%d\n' % (sprIndex,sa.frameDelays[i],deltaX,deltaY))
                sa.numFrames = i+1
            if (deltaX,deltaY) not in spriteImageRefs[sprIndex]:
                spriteImageRefs[sprIndex].append((deltaX,deltaY))
        f.write('.byte 0\n\n')
        sa.xAdd = xAdd
        sa.xAddFlipped = xAddFlipped
        sa.yAdd = yAdd

    f.write('SprAnimAddrLo:\n')
    for i,sa in enumerate(spriteAnimations):
        f.write('.byte <SprAnimAddr_%s\n' % spriteAnimationDirs[i])
    f.write('\n')
    f.write('SprAnimAddrHi:\n')
    for i,sa in enumerate(spriteAnimations):
        f.write('.byte >SprAnimAddr_%s\n' % spriteAnimationDirs[i])
    f.write('\n')

    f.write('SprAnimEnd: .byte %s\n' % string.join([str(4*(1+sa.numFrames)) for sa in spriteAnimations],','))

    for s in ['xAdd','xAddFlipped']: #,'yAdd']:
        f.write('.define %sTab %s\n' % (s,string.join([str(getattr(sa,s)) for sa in spriteAnimations],',')))
        f.write('%sTabLo: .lobytes %sTab\n' % (s,s))
        f.write('%sTabHi: .hibytes %sTab\n' % (s,s))
        f.write('.EXPORT %sTabLo\n' % s)
        f.write('.EXPORT %sTabHi\n' % s)

    # Print references to sprite images
    #f.write('; sprite references\n')
    #for i,refs in enumerate(spriteImageRefs):
    #    f.write('; spr%d: ' % i)
    #    for ref in refs:
    #        f.write(str(ref))
    #    f.write('\n')
#
# Run as stand-alone program
#        
if __name__ == "__main__":
    if len(sys.argv) < 2:
        print "Usage: unify_animations.py <animation name #1> ... <animation name #N>"
        sys.exit(2)
    #print sys.argv[1:]
    animationNames0= [  "null_image",
                        "goodguy",
                        "monkey_swinging",
                        "monkey_happy",
                        "crosshair",
                        "banana",
                        "thankyou",
                        ]
    unifySpriteAnimations([animationNames0])
    
