.proc GoodGuyAI

ACTORCLASS      = DEFAULT_ACTOR
actorRunningSpeed    = actorData3
actorDelayLo         = actorData1
actorDelayHi         = actorData2

GOODGUY_DELAY = 65000
    
    ldy actorMapPos,x
    jsr SetMapPos
    mb { actorFlagsZP := actorFlagsZP|#1 }
    ACTOR_SET_PALETTE #3
    ACTOR_SET_PRIORITY 1
    ACTOR_SET_ANIMATION #ANIMATION_GOODGUY
    lda #1
    sta actorHiX,x
    lda #2
    sta actorRunningSpeed,x

    lda #>GOODGUY_DELAY
    sta actorDelayHi,x
    lda #<GOODGUY_DELAY
    sta actorDelayLo,x

WaitUntilDelayDone:
    YIELD
    sec
    lda actorDelayLo,x
    sbc #1
    sta actorDelayLo,x
    lda actorDelayHi,x
    sbc #0
    sta actorDelayHi,x
    bne WaitUntilDelayDone

Idle:
    jsr UpdatePosForward
    lda actorHiX,x
    and #1
    bne :+
    lda actorLoX,x
    cmp #180
    beq TurnAround
:   
    YIELD
    jmp Idle


TurnAround:
    mb { actorFlagsZP := actorFlagsZP|#$40 }
Idle2:
    jsr UpdatePosBackward
    lda actorLoX,x
    cmp #0
    beq Disappear
    YIELD
    jmp Idle2

Disappear:
    KILL_SELF

UpdatePosForward:
    lda actorLoX,x
    clc
    adc actorRunningSpeed,x
    sta actorLoX,x
    lda actorHiX,x
    and #1
    adc #0
    sta actorHiX,x
    rts

UpdatePosBackward:
    lda actorLoX,x
    sec
    sbc actorRunningSpeed,x
    sta actorLoX,x
    lda actorHiX,x
    and #1
    sbc #0
    sta actorHiX,x
    rts

.endproc
