.IFNDEF __COMMON_H__
__COMMON_H__ = 1
.SETCPU "6502X"
.include "mapper.h"
.GLOBAL     MemCopySub,delay_256a_x_33_clocks,ClearRAM,Rand
.GLOBAL     Identity
.GLOBALZP   TEMP,NMITEMP,delayMacroVar,frameCounter

.MACPACK generic
.MACPACK longbranch
.INCLUDE "highlevel.h"

.MACRO MEMCPY dst,src,cnt
        lda #<src
        sta TEMP
        lda #>src
        sta TEMP+1
        lda #<dst
        sta TEMP+2
        lda #>dst
        sta TEMP+3
        ldx #<cnt
        lda #>cnt
        jsr MemCopySub
.ENDMACRO

.MACRO SELECT_CASE state
    .local jumpTable
    lda state
    asl
    tax
    lda jumpTable,x
    sta TEMP+0
    lda jumpTable+1,x
    sta TEMP+1
    jmp (TEMP)
jumpTable:
.ENDMACRO

.MACRO TST arg
    .if (.match (.left (1, {arg}), #))
        ; immediate mode - simulate with Identity table
        bit Identity+(.right (.tcount ({arg})-1, {arg}))
    .else
        ; absolute or zero page mode
        bit arg
    .endif
.ENDMACRO
.define tst TST
    
.macro DELAY arg
.if arg = 2
    nop
.endif
.if arg = 3
    sta delayMacroVar
.endif
.if arg = 4
    nop
    nop
.endif
.if arg = 5
    nop
    sta delayMacroVar
.endif
.if arg = 6
    nop
    nop
    nop
.endif
.if arg = 7
    nop
    nop
    sta delayMacroVar
.endif
.if arg = 8
    nop
    nop
    nop
    nop
.endif
.if arg = 9
    nop
    nop
    nop
    sta delayMacroVar
.endif
.if arg = 10
    nop
    nop
    nop
    nop
    nop
.endif
.if arg = 11
    nop
    nop
    nop
    nop
    lda delayMacroVar
.endif
.if arg = 12
    ;
    inc delayMacroVar
    inc delayMacroVar
    ; 10 cycles
    nop
.endif
.if arg = 13
    ;
    inc delayMacroVar
    inc delayMacroVar
    ; 10 cycles
    sta delayMacroVar
.endif
.if arg = 14
    ;
    inc delayMacroVar
    inc delayMacroVar
    ; 10 cycles
    nop
    nop
.endif
.if arg = 15
    ;
    inc delayMacroVar
    inc delayMacroVar
    ; 10 cycles
    nop
    sta delayMacroVar
.endif
.if arg = 16
    ;
    inc delayMacroVar
    inc delayMacroVar
    ; 10 cycles
    nop
    nop
    nop
.endif
.if arg = 17
    ;
    inc delayMacroVar
    inc delayMacroVar
    ; 10 cycles
    nop
    nop
    sta delayMacroVar
.endif
.if arg = 18
    ;
    inc delayMacroVar
    inc delayMacroVar
    ; 10 cycles
    nop
    nop
    nop
    nop
.endif
.if arg = 19
    ;
    inc delayMacroVar
    inc delayMacroVar
    ; 10 cycles
    nop
    nop
    nop
    sta delayMacroVar
.endif
.if arg = 20
    ;
    inc delayMacroVar
    inc delayMacroVar
    ; 10 cycles
    nop
    nop
    nop
    nop
    nop
.endif
.if arg = 21
    ;
    inc delayMacroVar
    inc delayMacroVar
    inc delayMacroVar
    ; 15 cycles
    lda delayMacroVar
    lda delayMacroVar
.endif
.if arg = 22
    ;
    inc delayMacroVar
    inc delayMacroVar
    inc delayMacroVar
    inc delayMacroVar
    ; 20 cycles

    nop
.endif
.if arg = 23
    ;
    inc delayMacroVar
    inc delayMacroVar
    inc delayMacroVar
    inc delayMacroVar
    ; 20 cycles

    sta delayMacroVar
.endif
.if arg = 24
    ;
    inc delayMacroVar
    inc delayMacroVar
    inc delayMacroVar
    inc delayMacroVar
    ; 20 cycles
    nop
    nop
.endif
.if arg = 25
    ;
    inc delayMacroVar
    inc delayMacroVar
    inc delayMacroVar
    inc delayMacroVar
    ; 20 cycles
    nop
    sta delayMacroVar
.endif
.if arg = 26
    ;
    inc delayMacroVar
    inc delayMacroVar
    inc delayMacroVar
    inc delayMacroVar
    ; 20 cycles
    nop
    nop
    nop
.endif
.if arg = 27
    ;
    inc delayMacroVar
    inc delayMacroVar
    inc delayMacroVar
    inc delayMacroVar
    ; 20 cycles
    nop
    nop
    sta delayMacroVar
.endif
.if arg = 28
    ;
    inc delayMacroVar
    inc delayMacroVar
    inc delayMacroVar
    inc delayMacroVar
    ; 20 cycles
    nop
    nop
    nop
    nop
.endif
.if arg = 29
    ;
    inc delayMacroVar
    inc delayMacroVar
    inc delayMacroVar
    inc delayMacroVar
    ; 20 cycles
    nop
    nop
    nop
    sta delayMacroVar
.endif
.if arg = 30
    ;
    inc delayMacroVar
    inc delayMacroVar
    inc delayMacroVar
    inc delayMacroVar
    inc delayMacroVar
    inc delayMacroVar
    ; 30 cycles
.endif
.if arg = 31
    ;
    inc delayMacroVar
    inc delayMacroVar
    inc delayMacroVar
    inc delayMacroVar
    inc delayMacroVar
    ; 25 cycles
    nop
    nop
    nop
.endif
.if arg = 32
    ;
    inc delayMacroVar
    inc delayMacroVar
    inc delayMacroVar
    inc delayMacroVar
    inc delayMacroVar
    inc delayMacroVar
    ; 30 cycles
    nop
.endif
.if arg = 33
    ;
    inc delayMacroVar
    inc delayMacroVar
    inc delayMacroVar
    inc delayMacroVar
    inc delayMacroVar
    inc delayMacroVar
    ; 30 cycles
    lda delayMacroVar
.endif
.if arg = 34
    ;
    inc delayMacroVar
    inc delayMacroVar
    inc delayMacroVar
    inc delayMacroVar
    inc delayMacroVar
    inc delayMacroVar
    ; 30 cycles
    nop
    nop
.endif
.if arg = 35
    ;
    inc delayMacroVar
    inc delayMacroVar
    inc delayMacroVar
    inc delayMacroVar
    inc delayMacroVar
    inc delayMacroVar
    ; 30 cycles
    nop
    lda delayMacroVar
.endif
.if arg = 36
    ;
    inc delayMacroVar
    inc delayMacroVar
    inc delayMacroVar
    inc delayMacroVar
    inc delayMacroVar
    inc delayMacroVar
    ; 30 cycles
    nop
    nop
    nop
.endif
.if arg >= 37
    lda #>(arg-37)
    ldx #<(arg-37)
    jsr delay_256a_x_33_clocks
.endif
.endmacro
.ENDIF ; __COMMON_H__
