.SETCPU "6502X"

.include "common.h"
.include "input.h"

JOY_A       = %00000001
JOY_B       = %00000010
JOY_SELECT  = %00000100
JOY_START   = %00001000
JOY_UP      = %00010000
JOY_DOWN    = %00100000
JOY_LEFT    = %01000000
JOY_RIGHT   = %10000000

ZAPPER_TRIGGER  = $08
ZAPPER_DETECT   = $10

.ZEROPAGE
joy:
joy0:                   .res 1
joy1:                   .res 1

joyP:
joyP0:                  .res 1
joyP1:                  .res 1

switchJoypadsFlag:      .res 1

zapper:
zapper0:                .res 1
zapper1:                .res 1

zapperP:
zapperP0:               .res 1
zapperP1:               .res 1


.CODE
ReadJoypads:
    ldx #0
    jsr     ReadJoy
    inx
    ;jsr     ReadJoy

ReadJoy:
    ldy    #1
    sty     $4016
    dey
    sty     $4016

    lda     joy,X
    pha

.repeat 8
    lda $4016,x
    lsr
    ror joy,X
.endrep
    lda joy,x
    pha
    
    ldy #1
    sty $4016
    dey
    sty $4016
.repeat 8
    lda $4016,x
    lsr
    ror joy,X
.endrep
    pla
    cmp joy,x
    beq :+
    ldy #1
    sty $4016
    dey
    sty $4016
.repeat 8
    lda $4016,x
    lsr
    ror joy,X
.endrep
:
    pla
    eor joy,X
    and joy,X
    sta joyP,X
    rts

SwitchJoypads:
    lda joyP0
    ora joyP1
    and #JOY_SELECT
    beq :+
    lda switchJoypadsFlag
    eor #$80
    sta switchJoypadsFlag
:
    rts

ExchangeJoypads:
    bit switchJoypadsFlag
    bpl :+
    lda joy0
    ldx joy1
    sta joy1
    stx joy0
    lda joyP0
    ldx joyP1
    sta joyP1
    stx joyP0
:
    rts

ReadZapper:
        ldx     #0
        lda     zapper,X
        PHA
        lda     $4016,X
        AND     #$18
        EOR     #$08
        ASL
        ASL
        ASL
        sta     zapper,X
        PLA
        sta     TEMP
        EOR     zapper,X
        AND     zapper,X
        STA     zapperP0,X
        lda     TEMP
        EOR     zapper,X
        and     TEMP
        LSR
        LSR
        LSR
        LSR
        ORA     zapperP0,X
        STA     zapperP0,X
        rts
