.SETCPU "6502X"

.include "common.h"
.include "maploader.h"
.include "level.h"
.include "map.h"
.include "actor.h"
.include "soundcode.h"

.ZEROPAGE
PortalListPtr:      .res 2
waterLevel:         .res 1

.CODE

.scope Jungle
Map:
;.INCBIN "levels/jungle/jungle_0_0.bin"
ActorList:
.byte (ActorListEnd-1-ActorList)/2
.byte $C6,ACTOR_TYPE_GOODGUY
.byte $A8,ACTOR_TYPE_CROSSHAIR
ActorListEnd:
WaterLevel:
.byte 164
Music:
.byte MUSIC_CLOUDBOSS
.endscope

.DEFINE MapPtrs Jungle::Map
MapPtrTabLo:
.lobytes MapPtrs
MapPtrTabHi:
.hibytes MapPtrs

.IMPORT bgMap_jungle_0_0
.DEFINE BGPtrs bgMap_jungle_0_0
BGPtrTabLo:
.lobytes BGPtrs
BGPtrTabHi:
.hibytes BGPtrs

.proc LoadMap
    actorSpawnPosition      = TEMP+2
    ptr                     = TEMP+12
    numActorsToSpawn        = TEMP+14
    tempY                   = TEMP+15

    pha
    SWITCH_PRG #BANK_LEVELDATA
    jsr FreeAllActors    
    jsr LoadLevel
    pla
    tay
    lda MapPtrTabLo,y
    sta ptr
    lda MapPtrTabHi,y
    sta ptr+1
    
    lda BGPtrTabLo,y
    sta bgMapPtr
    lda BGPtrTabHi,y
    sta bgMapPtr+1
    
    SWITCH_PRG #BANK_ACTORCODE
    ; Spawn actors
    ldy #0
    lda (ptr),y
    iny
    sta numActorsToSpawn
    do
        lda (ptr),y
        iny
        sta actorSpawnPosition
        lda (ptr),y
        iny
        sty tempY
        ldy actorSpawnPosition
        jsr AddActor
        ldy tempY
        dec numActorsToSpawn
    while not zero  
    lda (ptr),y
    iny
    ;sta waterLevel
    lda (ptr),y
    jsr SoundIssue
    
    ;mw bgMapPtr := #bgMap
    rts
.endproc
