.SETCPU "6502X"

.include "mapper.h"

.IMPORT MainCode,NMI,IRQ
.EXPORT RESET

.segment "INESHDR"
.byte "NES",$1A
.byte 8   ; 16 kB PRG banks
.byte 0   ; 8kB CHR RAM
.byte $40 ; Mapper 4, no SRAM battery
.byte 0   ; Flags
.byte 0,0,0,0,0,0,0,0

BANK_ACTORCODE  = 0
BANK_PHYSCODE   = 2
BANK_PPUCODE    = 1
BANK_OAMCODE    = 1
BANK_LEVELDATA  = 2
BANK_MAPEDITOR  = 2
BANK_DRAGONCHR  = 3
BANK_SOUNDCODE  = 4

.ZEROPAGE
currentBank:    .res 1

.segment "BOOT"
RESET:
    sei
    cld
    ldx #$FF
    txs
    inx
    stx $2000
    stx $2001
    
:
    lda $2002
    bpl :-
    
:
    lda $2002
    bpl :-
    
    ; Select 16kb bank 0 at $8000-$BFFF
    SWITCH_PRG #0
    ; Set 8kb VRAM configuration
    MMC3_WriteRegister #0, #0
    MMC3_WriteRegister #1, #1
    MMC3_WriteRegister #2, #4
    MMC3_WriteRegister #3, #5
    MMC3_WriteRegister #4, #6
    MMC3_WriteRegister #5, #7
    ; Set vertical mirroring
    lda #0
    sta $A000
    ; Enable PRG-RAM
    lda #$80
    sta $A001
    ; Disable IRQs
    sta $E000
    jmp MainCode

.segment "VECTORS"
.word NMI
.word RESET
.word IRQ
