.IFNDEF __MAPPER_H__
__MAPPER_H__ = 1
.SETCPU "6502X"

.GLOBALZP currentBank
.GLOBALZP BANK_ACTORCODE,BANK_PHYSCODE,BANK_PPUCODE,BANK_LEVELDATA,BANK_OAMCODE,BANK_MAPEDITOR,BANK_DRAGONCHR,BANK_SOUNDCODE

.MACRO MMC3_WriteRegister register, value
    lda register
    sta $8000
    lda value
    sta $8001
.ENDMACRO

.MACRO SWITCH_PRG bank
    ldx #$06
    stx $8000
    lda bank
    sta currentBank
    asl
    sta $8001
    inx
    stx $8000
    ora #1
    sta $8001
.ENDMACRO

; 2+4+2(3)+2+4+2+4+2+4 = 26(27) cycles
.MACRO NMI_SWITCH_PRG bank
    ldx #$06    ; 2
    stx $8000   ; 4
    lda bank    ; 2(3)
    asl         ; 2
    sta $8001   ; 4
    inx         ; 2
    stx $8000   ; 4
    ora #1      ; 2
    sta $8001   ; 4
.ENDMACRO

.MACRO IRQ_SETUP scanline
    ;lda #$0F
    ;sta $4015
    ;lda #$7F
    ;sta $4011
    ;lda #$F8
    ;lda $4012
    ;lda #$02
    ;sta $4013
    ;lda #$8F
    ;sta $4010
    ;lda #$1F
    ;sta $4015
    lda scanline
    sec
    sbc #25
    sta $C000
    sta $C001
    sta $E001
.ENDMACRO

.MACRO IRQ_ACKNOWLEDGE
    ;lda #$0F
    ;sta $4015
    sta $E000
.ENDMACRO

.ENDIF ; __MAPPER_H__
