.SETCPU "6502X"

.include "soundcode.h"
.include "common.h"
.include "mapper.h"

FT_BASE_ADR		= $0500
FT_TEMP             = NMITEMP

.ZEROPAGE
;FT_TEMP:        .res 7
soundIssued:    .res 2

.CODE

NTSC_MODE = $80

SoundInit:
    SWITCH_PRG #BANK_SOUNDCODE
	lda #NTSC_MODE
	jsr FamiToneInit		;init FamiTone

	;ldx #LOW(music_dpcm)	;set DPCM sample table location
	;ldy #HIGH(music_dpcm)
	;jsr FamiToneSampleInit

    ldx #<sounds		;set sound effects data location
	ldy #>sounds
	jsr FamiToneSfxInit
    
    lda #MUSIC_CLOUDBOSS
    jsr SoundIssue
    rts

    
SoundIssue:
    pha
    lda soundIssued
    bne :+
    pla
    sta soundIssued
    rts
:
    pla
    sta soundIssued+1
    rts
    
NewSound:
    ; Stop music if A = 0
    cmp #MUSIC_OFF
    bne :+
    jmp FamiToneMusicStop
:
    cmp #$00
    bmi @issueSFX
    tay
    ldx MusicPointersLo,y
    lda MusicPointersHi,y
    tay
    jmp FamiToneMusicStart
@issueSFX:
    sec
    sbc #$80
    pha
    tay
    ldx SfxChannel,y
    pla
    jmp FamiToneSfxStart
    
SoundUpdate:
    NMI_SWITCH_PRG #BANK_SOUNDCODE
    lda soundIssued
    beq :+
    jsr NewSound
:
    lda soundIssued+1
    beq :+
    jsr NewSound
:
    lda #$00
    sta soundIssued
    sta soundIssued+1
    jmp FamiToneUpdate

.SEGMENT "SOUNDCODE"
.include "sound/famitone.s"

.include "sound/cloudboss.s"

.include "sound/sounds.s"

.DEFINE MusicPointers 0, cloudboss_module

MusicPointersLo: .LOBYTES MusicPointers
MusicPointersHi: .HIBYTES MusicPointers

SfxChannel:
.byte FT_SFX_CH0
.byte FT_SFX_CH1
.byte FT_SFX_CH2
.byte FT_SFX_CH3
.byte FT_SFX_CH0
.byte FT_SFX_CH1
.byte FT_SFX_CH1
.byte FT_SFX_CH0
.byte FT_SFX_CH0
